unit SmartFontListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,extctrls;

type
  TSmartFontListBox = class(TListBox)
  private
    FHIntW    :THintWindow;
    FSelFontName   :string;
    FShowFontNames :Boolean;
    function GetSelFontName:String;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure Fontimerproc(Sender:TObject);
  protected
    release_timer      :ttimer;
  public
    constructor Create (AOwner: TComponent); override;
    destructor destroy; override;
    procedure CreateWnd; override;
    property SelFontName :String read GetSelFontName;
  published
    property ShowFontNames :Boolean read FShowFontNames write FShowFontNames default true;
    property onmousemove;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Smart', [TSmartFontListBox]);
end;

constructor TSmartFontListBox.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FHIntW:=THintWindow.Create(self);
  FShowFontNames:=True;
  release_timer:=ttimer.create(self);
  release_timer.interval:=1000;
  release_timer.enabled:=false;
  release_timer.ontimer:=Fontimerproc;
end;

destructor TSmartFontListBox.destroy;
begin
  release_timer.free;
  inherited destroy;
end;

procedure TSmartFontListBox.CreateWnd;
begin
  inherited CreateWnd;
  Items := Screen.Fonts;
end;

procedure TSmartFontListBox.MouseMove(Shift: TShiftState; X, Y: Integer);
var apoint,p    :tpoint;
    R           :TRect;
    the_length  :integer;
begin
  inherited MouseMove(Shift,X,Y);
  if not FShowFontNames then
    exit;
  apoint.x:=x;
  apoint.y:=y;
  p:=clienttoscreen(apoint);

  FHIntW.Canvas.Font.Size:=10;
  if ItemAtPos(APoint, True) <0 then
    exit;
  the_length:=FHIntW.Canvas.Font.Size * length(items[ItemAtPos(APoint, True)]);
  if the_length <70 then
    the_length:=70;
  R:=Rect(p.x+12,p.y-itemheight-2,p.x+the_length+2,p.y);

  FHIntW.Canvas.Font.Name:=items[ItemAtPos(APoint, True)];
  FHIntW.ActivateHint(R,items[ItemAtPos(APoint, True)]);
  release_timer.enabled:=true;
  
end;

procedure TSmartFontListBox.Fontimerproc(Sender:TObject);
begin
  release_timer.enabled:=false;
  FHIntW.ReleaseHandle;
end;

function TSmartFontListBox.GetSelFontName:String;
begin
  Result:=items[itemindex];
end;

end.
